#ifndef I2C_H_
#define I2C_H_

#include "def.h"

#define I2CERR_NAK          11
#define I2C_DELAY()        {asm volatile ("nop \n" "nop \n" "nop \n" "nop \n" "nop \n");}



class CI2C
    {
    public :

    int Init(u16 pinSCL, u16 pinSDA);
    int XmtByte(u8 devId, u8 addr, u8 data);
    int XmtBuf(u8 devId, u8 addr, int nBytes, u8* pBuf);
    u8  RcvByte(u8 devId, u8 addr);
    int RcvBuf(u8 devId, u8 addr, int nBytes, u8* pBuf);

    private:

    int  Start();
    int  Stop();
    int  XBit(int bit);
    int  RBit();
    int  XBitSlow(int bit);
    int  RBitSlow();
    int  XByte(u8 dat);
    u8   RByte(int ack);

    u16 m_SCLH;
    u16 m_SCLW;
    u16 m_SDAH;
    u16 m_SDAW;
    int m_error;
    };


#endif

/*
 * $Header: $
 */
