##########################################################################################
# HAM Makefile
#
# Created by Visual HAM V2 - Get Visual HAM at www.console-dev.de
#
##########################################################################################
HAMDIR = d:\gameboy\vh

include $(HAMDIR)/system/master.mak

# Set the name of your desired GBA image name here

PROGNAME=vario


# Compile using Krawall software (set to yes or no) ?
# Also specify if Krawall is registered (yes or no)

USE_KRAWALL=no
KRAWALL_IS_REGISTERED=no
KRAWALL_FILES=

# Custom adds for hel library usage
INCDIR += -I $(HAMDIR)/src  -I .

# Set a list of files you want to compile

AUDIO_OFILES = 0.o \
	1.o \
	2.o \
	3.o \
	4.o \
	5.o \
	6.o \
	7.o \
	8.o \
	9.o \
	10.o \
	11.o \
	12.o \
	13.o \
	14.o \
	15.o \
	16.o \
	yes.o \
	no.o \
	point.o \
	metres.o \
	mps.o \
	kph.o \
	attention.o \
	notbad.o \
	ok.o \
	verygood.o \
	excellent.o \
	danger.o \
	warning.o \
	sinking.o \
	whatrusinking.o \
	am.o \
	pm.o \
	celsius.o \
	up.o \
	down.o \
	north.o \
	south.o \
	east.o \
	west.o 
	
	
OFILES += main.o	\
	sensor.o	\
	vario.o	\
	rtc.o	\
	text.o	\
	tmr.o	\
	utils.o	\
	i2c.o	\
	ui.o	\
	bgtext.o \
	voice.o \
	$(AUDIO_OFILES)
	
IWRAM_OFILES = nvd.text.iwram.o

# Set a list of libraries you want to link

ADD_LIBS += $(HAMDIR)/lib/libhel2.a	


##########################################################################################
# Standard Makefile targets start here
##########################################################################################
all : $(PROGNAME).$(EXT)

gba : clean all fixheader

# Using custom-targets.mak  instead of standard-targets.mak
# this is for placing the nvd object code in IWRAM space

include custom-targets.mak

# include $(HAMDIR)/system/standard-targets.mak

##########################################################################################
# Custom  Makefile targets start here
##########################################################################################

nvd.text.iwram.o : nvd.o
	cp  nvd.o nvd.text.iwram.o

