#ifndef MS5534_H_
#define MS5534_H_


#define SENSOR_SCLK         PORT_SD
#define SENSOR_SCLK_WR      PORT_SD_WR

#define SENSOR_DIN          PORT_SC
#define SENSOR_DIN_WR       PORT_SC_WR

#define SENSOR_DOUT         PORT_SO
#define SENSOR_DOUT_WR      PORT_SO_WR

#define WRITE_1()       {PORT_REG |= SENSOR_DOUT;PORT_REG |= SENSOR_SCLK;PORT_REG &= ~SENSOR_SCLK;}
#define WRITE_0()       {PORT_REG &= ~SENSOR_DOUT;PORT_REG |= SENSOR_SCLK;PORT_REG &= ~SENSOR_SCLK;}
#define CLK()           {PORT_REG |= SENSOR_SCLK;PORT_REG &= ~SENSOR_SCLK;}
#define ACCUM(w,clk)    {PORT_REG |= SENSOR_SCLK;PORT_REG &= ~SENSOR_SCLK;w |= ((PORT_REG & SENSOR_DIN) << clk);}

#define START()                  {WRITE_1();WRITE_1();WRITE_1();}
#define STOP()                   {WRITE_0();WRITE_0();WRITE_0();}

#define CONV_COMPLETE()          ((PORT_REG & SENSOR_DIN ) == 0)

#define SENSOR_ST_IDLE           11
#define SENSOR_ST_TCONV          22
#define SENSOR_ST_PCONV          33

// approximately 65mS per P+T sample, which is about 15 P+T samples/second
#define SENSOR_SAMPLES_PER_SEC   15
#define SENSOR_MAX_SAMPLES       120

#endif

/*
 * $Header$
 */
