#ifndef NVD_H_
#define NVD_H_

#include "def.h"


#define NVD_SRAM        ((volatile unsigned char*) 0x0E004004)


class CNVD
    {
    public :
    int m_nCurInx;
    int  BadChecksum();
    void DeleteFlightRecord(int nrec);
    void ClearFlightRecord(int nrec);
    void CopyFlightRecord(int src, int dst);
    void WriteDefaults();
    int  ReadPZTblSel();
    int  ReadWindowSecs();
    int  ReadSinkThresholdCm();
    int  ReadCurInx();
    int  ReadKLPFC();
    int  ReadVarioRes();
    int  ReadVarioAudioMode();

    void WriteByte(int addr, int newVal);
    void WriteWord(int addr, int newVal);
    int  ReadWord(int addr);

    void WritePZTblSel(int newVal);
    void WriteWindowSecs(int newVal);
    void WriteSinkThresholdCm(int newVal);
    void WriteKLPFC(int newVal);
    void WriteVarioRes(int newVal);
    void WriteVarioAudioMode(int newVal);
    void WriteCurInx(int newVal);
    void WriteMaxCRCm(int inx, int maxcrcm);
    void WriteMaxSRCm(int inx, int maxsrcm);
    void WriteLaunchAltM(int inx, int altm);
    void WriteMaxAltM(int inx, int altm);
    void WriteLZAltM(int inx, int altm);
    void WriteFHrs(int inx, int fhrs);
    void WriteFMin(int inx, int fmin);
    void WriteFSec(int inx, int fsec);
    void WriteLMin(int inx, int lmin);
    void WriteLHr(int inx, int lhr);
    void WriteDom(int inx, int dom);
    void WriteMon(int inx, int mon);
    void WriteYear(int inx, int year);
    int  ReadYear(int inx);
    int  ReadMon(int inx);
    int  ReadDom(int inx);
    int  ReadLHr(int inx);
    int  ReadLMin(int inx);
    int  ReadFSec(int inx);
    int  ReadFMin(int inx);
    int  ReadFHrs(int inx);
    int  ReadMaxAltM(int inx);
    int  ReadLaunchAltM(int inx);
    int  ReadLZAltM(int inx);
    int  ReadMaxSRCm(int inx);
    int  ReadMaxCRCm(int inx);
    
    void UpdateChecksum();
    };


#endif

/*
 * $Header: $
 */

