#ifndef RTC_H_
#define RTC_H_

#include "def.h"

#define RTC_AM      0
#define RTC_PM      1

#define RTC_HRS_24  0
#define RTC_HRS_12  1

class CRTC
    {
    public :
    int m_sec;
    int m_min;
    int m_hrsmode;
    int m_ampm;
    int m_hrs;
    int m_dow;
    int m_dom;
    int m_mon;
    int m_yar;

    void Init();
    void ReadData();
    void WriteData();
    void UpdateDow(int dow);
    void IncrDow();
    void DecrDow();
    void UpdateDom(int dom);
    void IncrDom();
    void DecrDom();
    void UpdateMon(int mon);
    void IncrMon();
    void DecrMon();
    void UpdateYar(int yar);
    void IncrYar();
    void DecrYar();
    void UpdateHrs(int hrs, int hrsmode);
    void IncrHrs();
    void DecrHrs();
    void UpdateMin(int min);
    void IncrMin();
    void DecrMin();
    void UpdateSec(int sec);
    void IncrSec();
    void DecrSec();

    private :
    };

#endif

/*
 * $Header: $
 */
