#ifndef TEXT_H
#define TEXT_H

#include "def.h"

#define MAX_SPRITES_PER_FIELD   32
#define MAX_FIELD_CHARS     120

#define SCROLL_NCHARS(w,a)                 (240/(w-a) + 2)



typedef struct SPRITE_
    {
    int  inx;
    int  x;
    int  y;
    } SPRITE;




class CText
    {
    public:
        void  Init(const u16* pPalette, const u8* pRawSource, char* pCharOrder,int wid,int hgt,int bScroll,int bx,int by,int adj,char* pTemplate, u8 objShape, u8 objSize);
        void  Init(const u16* pPalette, const u8* pRawSource, char* pCharOrder,int wid,int hgt,int bScroll,int bx,int by,int adj,int nChars, u8 objShape, u8 objSize);
        void  SetText(char *pText);
        void  SetText(int nChars);
        void  Clear();
        void  SetPos(int x, int y);
        void  CreateSprites(u8 objShape, u8 objSize);
        void  DeleteSprites(void);
        void  DisplayScrollR2L();
        void  DisplayStatic();

    private:
        u16       * m_pPalette;
        u8        * m_pRawSource;        // Picture (Bitmap) Data
        char      * m_pCharOrder;
        int         m_wid;
        int         m_hgt;
        int         m_widhgt;
        int         m_bScroll;
        int         m_actCharPos;
        int         m_bx;
        int         m_by;
        int         m_adj;
        int         m_strLen;
        char        m_text[MAX_FIELD_CHARS];
        SPRITE      m_spriteInfo[MAX_SPRITES_PER_FIELD];
        inline int  CalcCharAddress(char Char);
        inline int  StrLen(char* pText);
    };


#endif /* TEXT_H */

/*
 * $Header: $
 */

