#include "tmr.h"


TIMER gTmr;

void tmr_ISR(void);

void CTimer::Init(int dow, int hrs, int min, int sec)
    {
    u16 tmrVal;
    int scaler;
    
    gTmr.ticks = 0;
    scaler = TMR_SCALER;
//    tmrVal = TMR_REG_VAL(1.0f/(f32)TMR_TICKS_PER_SEC,scaler);
    tmrVal = TMR_REG_VAL(TMR_TICK_MS,scaler);

    M_TIM2COUNT_SET(tmrVal);
    switch (scaler)
        {
        case  1 :
        default :
        M_TIM2CNT_SPEED_SELECT_SET(0);
        break;

        case  64 :
        M_TIM2CNT_SPEED_SELECT_SET(1);
        break;

        case  256 :
        M_TIM2CNT_SPEED_SELECT_SET(2);
        break;

        case  1024 :
        M_TIM2CNT_SPEED_SELECT_SET(3);
        break;
        }

    Reset();
    SetRealTime(dow,hrs,min,sec);
    M_TIM2CNT_TIMER_START;
    ham_StartIntHandler(INT_TYPE_TIM2,(void *)&tmr_ISR);
    M_TIM2CNT_IRQ_ENABLE;
    }
    

void CTimer::SetRealTime(int dow, int hrs, int min, int sec)
    {
    gTmr.rdow = dow;
    gTmr.rhrs = hrs;
    gTmr.rmins = min;
    gTmr.rsecs = sec;
    }


void CTimer::Reset()
    {
    gTmr.fsecs = 0;
    gTmr.fmins = 0;
    gTmr.fhrs = 0;
    gTmr.tickCntr = 0;
    gTmr.varioTickFlag = false;
    gTmr.secFlag = false;
    gTmr.runFlag = false;
    }
    

void tmr_ISR(void)
	{
   gTmr.ticks++;
   gTmr.tickCntr++;
   if (gTmr.tickCntr == TMR_TICKS_PER_SEC)
      {
      gTmr.tickCntr = 0;
      gTmr.secFlag = true;

      // update real time clock
      gTmr.rsecs++;
      if (gTmr.rsecs > 59)
         {
         gTmr.rsecs = 0;
         gTmr.rmins++;
         if (gTmr.rmins > 59)
            {
            gTmr.rmins = 0;
            gTmr.rhrs++;
            if (gTmr.rhrs > 23)
               {
               gTmr.rhrs = 0;
               }
            }
         }

      // update flight duration clock
      if (gTmr.runFlag) 
         {
         gTmr.fsecs++;
         if (gTmr.fsecs > 59)
            {
            gTmr.fsecs = 0;
            gTmr.fmins++;
            if (gTmr.fmins > 59)
               {
               gTmr.fmins = 0;
               gTmr.fhrs++;
               if (gTmr.fhrs > 99)
                  {
                  gTmr.fhrs = 0;
                  }
               }
            }
         }
	   }

   // update vario chirp flag counter
   gTmr.varioCntr++;
   if (gTmr.varioCntr == VARIO_TMR_TICKS)
      {
      gTmr.varioCntr = 0;
      gTmr.varioTickFlag = true;
      }
   }

/*
 * $Header: $
 */

