#include "def.h"
#include "tmr.h"
#include "utils.h"

#define IO_BASE       ((u8*)0x4000000)
#define DMA_ENABLE    ((u16)(0x8000))
#define DMA_STARTNOW  ((u16)(0x0000))
#define DMA_32BIT     ((u16)(0x0400))
#define REG_DMA3SAD   ((vu32*)(IO_BASE + 0x00000d4))
#define REG_DMA3DAD   ((vu32*)(IO_BASE + 0x00000d8))
#define REG_DMA3COUNT ((vu16*)(IO_BASE + 0x00000dc))
#define REG_DMA3CNT   ((vu16*)(IO_BASE + 0x00000de))


    
void BusyWait(int ms)
   {
   u32 busyWaitTick;
   
   busyWaitTick = WAIT_TICK(ms);
   while (gTmr.ticks < busyWaitTick) ;
   }


void MemCopy(void* src, void* dst, u32 size)
    {
    u16 cntl = DMA_ENABLE | DMA_STARTNOW;

    *REG_DMA3SAD = (u32)src;
    *REG_DMA3DAD = (u32)dst;

    /* Number of words / halfwords */
    size = size >> 1;
    if(!(size & 1))
        {
        size = size >> 1;
        cntl |= DMA_32BIT;
        }
    *REG_DMA3COUNT = (u16)size;
    *REG_DMA3CNT = cntl;
    }


