#ifndef VARIO_H_
#define VARIO_H_

#include "def.h"

#define GBA_REG_SG10		   (*(volatile unsigned long *)0x4000060)
#define GBA_REG_SG10_L		(*(volatile unsigned short *)0x4000060)
#define GBA_REG_SG10_H		(*(volatile unsigned short *)0x4000062)
#define GBA_REG_SG11		   (*(volatile unsigned short *)0x4000064)

#define GBA_REG_SGCNT0		(*(volatile unsigned long *)0x4000080)
#define GBA_REG_SGCNT0_L	(*(volatile unsigned short *)0x4000080)
#define GBA_REG_SGCNT0_H	(*(volatile unsigned short *)0x4000082)
#define GBA_REG_SGCNT1		(*(volatile unsigned short *)0x4000084)


#define VARIO_SOUND_RESET()         {M_SNDCNT1_OUTPUT_LEFT_ALL_OFF; M_SNDCNT1_OUTPUT_RIGHT_ALL_OFF; GBA_REG_SG11 |= 0x8000; M_SND1CNT3_SETUP(1, 1);}

#define VARIO_FREQ2REG(nHz)         ((u16)(((nHz<<11) - 131072)/(nHz)))

#define VARIO_MAX_SWEEP_TIME          7
#define VARIO_MIN_SWEEP_TIME          1
#define VARIO_SWEEP_INCR              0
#define VARIO_SWEEP_DECR              1
#define VARIO_LOOP_TIMED              1
#define VARIO_LOOP_CONT               0

#define VARIO_MAX_CLIMB_FREQ          1800
#define VARIO_CROSSOVER_CLIMB_FREQ    1400
#define VARIO_MIN_CLIMB_FREQ          300
#define VARIO_SINK_FREQ_LO            400
#define VARIO_SINK_FREQ_HI            800

class CVario
    {
    public :
    int m_nCmPerSec;
    int m_nSinkThresholdCm;
    int m_nResolutionCm;
    int m_nMode;
    
    void Init();
    void SetMode(int nMode);
    void Chirp(int nCmPerSec);
    void Voice(int nCmPerSec);

    private :

    u16 m_nNumSweeps;
    u16 m_nSweepTime;
    u16 m_nSweepDir;
    u16 m_nFreqReg;
    u16 m_nInitVolume;
    u16 m_nFadeMode;
    u16 m_nSoundLen;
    u16 m_nDutyCycle;
    u16 m_nVolumeSteps;
    u16 m_nLoopMode;
    int  m_nTickCnt;
    int  m_nTotalTicks;
    };

#endif

/*
 * $Header: $
 */

