#include "voice.h"


int CVoice::Init()
   {
   // no voice selected
   m_nVoiceSel = -1;
   M_SNDCNT2_DSOUNDA_OUTPUT_R_ENABLE(1);
   M_SNDCNT2_DSOUNDA_OUTPUT_L_ENABLE(1);

	// Initializes the ham Direct Sound mixer.
    // To ensure click less playback, set your Mixer to a frequency outlined above.
    // Other frequencies might play back fine, but these are safer to use, the ones
    // above fit the timing of the GBA best. After you Initialized your Mixer, you must
    // call ham_SyncMixer in your VBL handler, at the very top, and also ham_UpdateMixer
    // once per frame, where does not matter.
	ham_InitMixer(MIXER_FREQ);

	// Use this function to initialize a Sample for later playing using ham_PlaySample.
    // The parameters are quite easy to figure out, just make sure your data pointer
    // actually points to a raw, 8bit, mono signed sound sample.
	m_wave[S_0] =  ham_InitSample((u8*)_binary_0_raw_start.data,  // the pointer to your RAW 8bit signed sound data
                   _binary_0_raw_start.size,                      // the length of the sound data, in bytes
                   _binary_0_raw_start.freq>>10);                 // the bitrate of the sound data, in Hz
	m_wave[S_1] =  ham_InitSample((u8*)_binary_1_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_1_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_1_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_2] =  ham_InitSample((u8*)_binary_2_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_2_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_2_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_3] =  ham_InitSample((u8*)_binary_3_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_3_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_3_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_4] =  ham_InitSample((u8*)_binary_4_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_4_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_4_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_5] =  ham_InitSample((u8*)_binary_5_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_5_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_5_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_6] =  ham_InitSample((u8*)_binary_6_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_6_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_6_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_7] =  ham_InitSample((u8*)_binary_7_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_7_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_7_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_8] =  ham_InitSample((u8*)_binary_8_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_8_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_8_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_9] =  ham_InitSample((u8*)_binary_9_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_9_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_9_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_10] =  ham_InitSample((u8*)_binary_10_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_10_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_10_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_11] =  ham_InitSample((u8*)_binary_11_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_11_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_11_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_12] =  ham_InitSample((u8*)_binary_12_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_12_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_12_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_13] =  ham_InitSample((u8*)_binary_13_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_13_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_13_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_14] =  ham_InitSample((u8*)_binary_14_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_14_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_14_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_15] =  ham_InitSample((u8*)_binary_15_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_15_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_15_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_16] =  ham_InitSample((u8*)_binary_16_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_16_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_16_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_YES] =  ham_InitSample((u8*)_binary_yes_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_yes_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_yes_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_NO] =  ham_InitSample((u8*)_binary_no_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_no_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_no_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_AM] =  ham_InitSample((u8*)_binary_am_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_am_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_am_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_PM] =  ham_InitSample((u8*)_binary_pm_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_pm_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_pm_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_KPH] =  ham_InitSample((u8*)_binary_kph_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_kph_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_kph_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_POINT] =  ham_InitSample((u8*)_binary_point_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_point_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_point_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_METRES] =  ham_InitSample((u8*)_binary_metres_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_metres_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_metres_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_ATTENTION] =  ham_InitSample((u8*)_binary_attention_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_attention_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_attention_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_OK] =  ham_InitSample((u8*)_binary_ok_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_ok_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_ok_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_NOTBAD] =  ham_InitSample((u8*)_binary_notbad_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_notbad_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_notbad_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_VERYGOOD] =  ham_InitSample((u8*)_binary_verygood_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_verygood_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_verygood_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_EXCELLENT] =  ham_InitSample((u8*)_binary_excellent_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_excellent_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_excellent_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_SINKING] =  ham_InitSample((u8*)_binary_sinking_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_sinking_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_sinking_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_WRUSINKING] =  ham_InitSample((u8*)_binary_whatrusinking_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_whatrusinking_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_whatrusinking_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_DANGER] =  ham_InitSample((u8*)_binary_danger_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_danger_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_danger_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_WARNING] =  ham_InitSample((u8*)_binary_warning_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_warning_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_warning_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_UP] =  ham_InitSample((u8*)_binary_up_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_up_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_up_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_DOWN] =  ham_InitSample((u8*)_binary_down_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_down_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_down_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_NORTH] =  ham_InitSample((u8*)_binary_north_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_north_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_north_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_SOUTH] =  ham_InitSample((u8*)_binary_south_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_south_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_south_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_EAST] =  ham_InitSample((u8*)_binary_east_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_east_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_east_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_WEST] =  ham_InitSample((u8*)_binary_west_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_west_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_west_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
	m_wave[S_CELSIUS] =  ham_InitSample((u8*)_binary_celsius_raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary_celsius_raw_start.size,                    // the length of the sound data, in bytes
                   _binary_celsius_raw_start.freq>>10);               // the bitrate of the sound data, in Hz
   /*
	m_wave[S_] =  ham_InitSample((u8*)_binary__raw_start.data,// the pointer to your RAW 8bit signed sound data
                   _binary__raw_start.size,                    // the length of the sound data, in bytes
                   _binary__raw_start.freq>>10);               // the bitrate of the sound data, in Hz
                   */
   return 0;
   }


void CVoice::SetBitRate(int nSel, int nBitRate)
   {
   m_wave[nSel]->bitrate = nBitRate;
   ham_ChangeSampleBitrate(m_wave[nSel],m_wave[nSel]->bitrate);
   }

void CVoice::Trigger()
   {
   if ( !m_wave[m_nVoiceSel]->playing )
       ham_PlaySample(m_wave[m_nVoiceSel]);
   }
