#ifndef VOICE_H_
#define VOICE_H_

#include <mygba.h>

// pointers to sample data converted using the wav2gba tool
extern const WaveData _binary_0_raw_start;
extern const WaveData _binary_1_raw_start;
extern const WaveData _binary_2_raw_start;
extern const WaveData _binary_3_raw_start;
extern const WaveData _binary_4_raw_start;
extern const WaveData _binary_5_raw_start;
extern const WaveData _binary_6_raw_start;
extern const WaveData _binary_7_raw_start;
extern const WaveData _binary_8_raw_start;
extern const WaveData _binary_9_raw_start;
extern const WaveData _binary_10_raw_start;
extern const WaveData _binary_11_raw_start;
extern const WaveData _binary_12_raw_start;
extern const WaveData _binary_13_raw_start;
extern const WaveData _binary_14_raw_start;
extern const WaveData _binary_15_raw_start;
extern const WaveData _binary_16_raw_start;
extern const WaveData _binary_point_raw_start;
extern const WaveData _binary_metres_raw_start;
extern const WaveData _binary_yes_raw_start;
extern const WaveData _binary_no_raw_start;
extern const WaveData _binary_kph_raw_start;
extern const WaveData _binary_am_raw_start;
extern const WaveData _binary_pm_raw_start;
extern const WaveData _binary_attention_raw_start;
extern const WaveData _binary_notbad_raw_start;
extern const WaveData _binary_ok_raw_start;
extern const WaveData _binary_verygood_raw_start;
extern const WaveData _binary_excellent_raw_start;
extern const WaveData _binary_sinking_raw_start;
extern const WaveData _binary_whatrusinking_raw_start;
extern const WaveData _binary_north_raw_start;
extern const WaveData _binary_south_raw_start;
extern const WaveData _binary_east_raw_start;
extern const WaveData _binary_west_raw_start;
extern const WaveData _binary_celsius_raw_start;
extern const WaveData _binary_danger_raw_start;
extern const WaveData _binary_warning_raw_start;
extern const WaveData _binary_up_raw_start;
extern const WaveData _binary_down_raw_start;
extern const WaveData _binary_mps_raw_start;

#define S_0  0
#define S_1  1
#define S_2  2
#define S_3  3
#define S_4  4
#define S_5  5
#define S_6  6
#define S_7  7
#define S_8  8
#define S_9  9
#define S_10  10
#define S_11  11
#define S_12  12
#define S_13  13
#define S_14  14
#define S_15  15
#define S_16  16
#define S_YES  17
#define S_NO  18
#define S_KPH 19
#define S_METRES 20
#define S_POINT 21
#define S_AM    22
#define S_PM    23
#define S_ATTENTION    24
#define S_NOTBAD        25
#define S_OK            26
#define S_VERYGOOD      27
#define S_EXCELLENT     28
#define S_SINKING       29
#define S_WRUSINKING    30
#define S_NORTH         32
#define S_SOUTH         33
#define S_EAST          34
#define S_WEST          35
#define S_DANGER              36
#define S_WARNING              37
#define S_UP              38
#define S_DOWN              39
#define S_CELSIUS              40
#define S_MPS              41

#define NUM_SOUND_SAMPLES 42

// Set the master mixer frequency (maximum bitrate)
// Note that not all values guarantee clickless playback
// please choose from one of these values:
// 5733  Hz   6689 Hz  10512 Hz   11467 Hz
// 13379 Hz  18157 Hz  20068 Hz   21024 Hz
// 26757 Hz  31536 Hz  36314 Hz   40136 Hz
// 42048 Hz  54471 Hz

// The sample bitrate is nominally 16000, but for the vario voice the
// maximum is 13000 + 100*64 = 19400. So the smallest acceptable
// mixer frequency is 20068 

#define MIXER_FREQ 20068

class CVoice
   {
   public :
   int  Init();
   void SetBitRate(int nSel, int nBitRate);
   void Trigger();

   sample_info* m_wave[NUM_SOUND_SAMPLES];
   int m_nVoiceSel;
   };

#endif
